Char::Reader - Crystal 0.35.1

# struct Char::Reader

- Char::Reader
- Struct
- Value
- Object

##
Overview

A `Char::Reader` allows iterating a `String` by Chars.

As soon as you instantiate a `Char::Reader` it will decode the first char in the `String`, which can be accessed by invoking `#current_char`. At this point `#pos`, the current position in the string, will equal zero. Successive calls to `#next_char` return the next chars in the string, advancing `#pos`.

Note that the null character `'\0'` will be returned in `#current_char` when the end is reached (as well as when the string is empty). Thus, `#has_next?` will return `false` only when `#pos` is equal to the string's bytesize, in which case `#current_char` will always be `'\0'`.

##
Included Modules

- Enumerable(Char)

##
Defined in:

##
Constructors

- .new(string : String, pos = 0)

  Creates a reader with the specified string positioned at byte index pos.

- .new(*, at_end string : String)

  Creates a reader that will be positioned at the last char of the given string.

##
Instance Method Summary

- #current_char : Char

  Returns the current character.

- #current_char_width : Int32

  Returns the size of the `#current_char` (in bytes) as if it were encoded in UTF-8.

- #each(&) : Nil

  Yields successive characters from `#string` starting from `#pos`.

- #error : UInt8?

  If there was an error decoding the current char because of an invalid UTF-8 byte sequence, returns the byte that produced the invalid encoding.

- #has_next?

  Returns `true` if there is a character left to read.

- #has_previous?

  Returns `true` if there are characters before the current one.

- #next_char

  Reads the next character in the string, `#pos` is incremented.

- #peek_next_char

  Returns the next character in the `#string` without incrementing `#pos`.

- #pos : Int32

  Returns the position of the current character.

- #pos=(pos)

  Sets `#pos` to pos.

- #previous_char : Char

  Returns the previous character, `#pos` is decremented.

- #string : String

  Returns the reader's String.

### Instance methods inherited from module `Enumerable(Char)`

all?(&)
all?(pattern)
all? all?, any?(&)
any?(pattern)
any? any?, chunks(&block : T -> U) forall U chunks, compact_map(&) compact_map, count(&)
count(item) count, cycle(&)
cycle(n, &) cycle, each(&block : T -> _) each, each_cons(count : Int, reuse = false, &) each_cons, each_cons_pair(& : T, T -> _) : Nil each_cons_pair, each_slice(count : Int, reuse = false, &) each_slice, each_with_index(offset = 0, &) each_with_index, each_with_object(obj, &) each_with_object, empty? empty?, find(if_none = nil, &) find, first(&)
first(count : Int)
first first, first? first?, flat_map(&block : T -> Array(U) | Iterator(U) | U) forall U flat_map, grep(pattern) grep, group_by(&block : T -> U) forall U group_by, in_groups_of(size : Int, filled_up_with : U = nil) forall U
in_groups_of(size : Int, filled_up_with : U = nil, reuse = false, &) forall U in_groups_of, includes?(obj) includes?, index(&)
index(obj) index, index_by(&block : T -> U) forall U index_by, join(separator = "", & : T -> )
join(separator, io : IO, &)
join(io : IO, separator = "", & : T, IO -> )
join(separator = "")
join(separator, io : IO)
join(io : IO, separator = "") join, map(&block : T -> U) forall U map, map_with_index(offset = 0, &block : T, Int32 -> U) forall U map_with_index, max max, max? max?, max_by(&block : T -> U) forall U max_by, max_by?(&block : T -> U) forall U max_by?, max_of(&block : T -> U) forall U max_of, max_of?(&block : T -> U) forall U max_of?, min min, min? min?, min_by(&block : T -> U) forall U min_by, min_by?(&block : T -> U) forall U min_by?, min_of(&block : T -> U) forall U min_of, min_of?(&block : T -> U) forall U min_of?, minmax minmax, minmax? minmax?, minmax_by(&block : T -> U) forall U minmax_by, minmax_by?(&block : T -> U) forall U minmax_by?, minmax_of(&block : T -> U) forall U minmax_of, minmax_of?(&block : T -> U) forall U minmax_of?, none?
none?(pattern)
none?(&) none?, one?(&)
one?(pattern)
one? one?, partition(&) partition, product
product(initial : Number)
product(initial : Number, &)
product(&) product, reduce(memo, &)
reduce(&) reduce, reduce?(&) reduce?, reject(pattern)
reject(type : U.class) forall U
reject(&block : T -> ) reject, select(pattern)
select(type : U.class) forall U
select(&block : T -> ) select, size size, skip(count : Int) skip, skip_while(&) skip_while, sum(initial)
sum
sum(initial, &)
sum(&) sum, take_while(&) take_while, tally : Hash(T, Int32) tally, to_a to_a, to_h
to_h(&block : T -> Tuple(K, V)) forall K, V to_h, to_set to_set, zip(*others : Indexable | Iterable | Iterator, &)
zip(*others : Indexable | Iterable | Iterator) zip, zip?(*others : Indexable | Iterable | Iterator, &)
zip?(*others : Indexable | Iterable | Iterator) zip?

### Instance methods inherited from struct `Struct`

==(other) : Bool ==, hash(hasher) hash, inspect(io : IO) : Nil inspect, pretty_print(pp) : Nil pretty_print, to_s(io : IO) : Nil to_s

### Instance methods inherited from struct `Value`

==(other : JSON::Any)
==(other : YAML::Any)
==(other) ==, dup dup

### Instance methods inherited from class `Object`

! : Bool !, !=(other) !=, !~(other) !~, ==(other) ==, ===(other : JSON::Any)
===(other : YAML::Any)
===(other) ===, =~(other) =~, as(type : Class) as, as?(type : Class) as?, class class, dup dup, hash(hasher)
hash hash, in?(*values : Object) : Bool
in?(collection) : Bool in?, inspect : String
inspect(io : IO) : Nil inspect, is_a?(type : Class) : Bool is_a?, itself itself, nil? : Bool nil?, not_nil! not_nil!, pretty_inspect(width = 79, newline = "\n", indent = 0) : String pretty_inspect, pretty_print(pp : PrettyPrint) : Nil pretty_print, responds_to?(name : Symbol) : Bool responds_to?, tap(&) tap, to_json(io : IO)
to_json to_json, to_pretty_json(io : IO, indent : String = " ")
to_pretty_json(indent : String = " ") to_pretty_json, to_s : String
to_s(io : IO) : Nil to_s, to_yaml(io : IO)
to_yaml to_yaml, try(&) try, unsafe_as(type : T.class) forall T unsafe_as

### Class methods inherited from class `Object`

from_json(string_or_io, root : String)
from_json(string_or_io) from_json, from_yaml(string_or_io : String | IO) from_yaml

##
Constructor Detail

def self.new(string : String, pos = 0) #

Creates a reader with the specified string positioned at byte index pos.

def self.new(*, at_end string : String) #

Creates a reader that will be positioned at the last char of the given string.

##
Instance Method Detail

def current_char : Char #

Returns the current character.

    reader = Char::Reader.new("ab")
    reader.current_char # => 'a'
    reader.next_char
    reader.current_char # => 'b'

def current_char_width : Int32 #

Returns the size of the `#current_char` (in bytes) as if it were encoded in UTF-8.

    reader = Char::Reader.new("aé")
    reader.current_char_width # => 1
    reader.next_char
    reader.current_char_width # => 2

def each(&) : Nil #

Yields successive characters from `#string` starting from `#pos`.

    reader = Char::Reader.new("abc")
    reader.next_char
    reader.each do |c|
      puts c.upcase
    end

    B
    C

def error : UInt8? #

If there was an error decoding the current char because of an invalid UTF-8 byte sequence, returns the byte that produced the invalid encoding. Returns `0` if the char would've been out of bounds. Otherwise returns `nil`.

def has_next? #

Returns `true` if there is a character left to read. The terminating byte `'\0'` is considered a valid character by this method.

    reader = Char::Reader.new("a")
    reader.has_next?      # => true
    reader.peek_next_char # => '\0'

def has_previous? #

Returns `true` if there are characters before the current one.

def next_char #

Reads the next character in the string, `#pos` is incremented. Raises `IndexError` if the reader is at the end of the `#string`.

    reader = Char::Reader.new("ab")
    reader.next_char # => 'b'

def peek_next_char #

Returns the next character in the `#string` without incrementing `#pos`. Raises `IndexError` if the reader is at the end of the `#string`.

    reader = Char::Reader.new("ab")
    reader.peek_next_char # => 'b'
    reader.current_char   # => 'a'

def pos : Int32 #

Returns the position of the current character.

    reader = Char::Reader.new("ab")
    reader.pos # => 0
    reader.next_char
    reader.pos # => 1

def pos=(pos) #

Sets `#pos` to pos.

    reader = Char::Reader.new("abc")
    reader.next_char
    reader.next_char
    reader.pos = 0
    reader.current_char # => 'a'

def previous_char : Char #

Returns the previous character, `#pos` is decremented. Raises `IndexError` if the reader is at the beginning of the `#string`

def string : String #

Returns the reader's String.